/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Message scanning, listing, killing, forwarding, moving, hurling        *
 *  and xporting.                                                          *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <dos.h>
#include <errno.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include "prog.h"
#include "ffind.h"
#include "alc.h"
#include "max.h"
#include "max_msg.h"

static int near pascal IsValidMsgArea(struct _area *a,int areanum);
static void near pascal Scan_LastRead_Pointer(void);
static void near pascal Scan_Msg_Numbers(int get_high);
static char * near pascal MsgDate(struct _msg *msg,char *datebuf);
static int near pascal CanKillMsg(struct _msg *msg);
static void near pascal Update_Scanfile(int mode,int msgnum,int scanfile);

void pascal Msg_Checkmail(void)
{
  struct _area *ar;

  if (infilearea)
    Last_Other();

  /* Make sure the current area is accessible, to avoid an ugly            *
   * "You can't get there" error message.                                  */

  if ((ar=malloc(sizeof(struct _area))) != NULL)
  {
    Read_Area(ar,usr.msg);

    if (! IsValidMsgArea(ar,0))    /* If invalid, set it to area 1. */
      usr.msg=prm.begin_msgarea;

    free(ar);
  }

  if (Last_Msg())
    return;

  found_msg=FALSE;

  strcpy(linebuf,"R*");
  Msg_Scan();

  /* Display a message to the user if we can't find any mail */

  if (!found_msg && *PRM(nomail))
    Display_File(0,NULL,PRM(nomail));

  /* Do an extra scan, to make sure we don't overwrite lastread ptr with   *
   * old one, when we get into Last_Other()                                */

  Scan_LastRead_Pointer();
  Last_Other();
}


void pascal Msg_Scan(void)
{
  struct _aidx aidx;

  char temp[PATHLEN],
       new,
       verbose,
       nonstop,
       read_msg,
       scan_datafile;

  int last_len,
      tempmsg,
      x,y;

  long aidxoff;

  new=verbose=FALSE;

  WhiteN();

  for (*temp='?';*temp=='?';)
  {
    OpusGets(temp,s(scan_p));

    if (*temp=='?')
      Display_File(0,NULL,PRM(hlp_scan));
  }

  Puts(CLS WHITE);

  if (inmsgarea)
    Fix_Lastread();

  display_line=display_col=1;
  nonstop=FALSE;
  read_msg=FALSE;
  last_len=0;

  strupr(temp);

  while (*temp=='*' || *temp=='V' || *temp=='R' || isspace(temp[0]) ||
         ispunct(temp[0]))
  {
    if (*temp=='*')
      new=TRUE;
    else if (*temp=='R')
    {
      read_msg=TRUE;
      in_mcheck=TRUE;
    }
    else if (*temp=='V')
      verbose=TRUE;

    memmove(temp,&temp[1],strlen(&temp[1])+1);  /* Shift it back one */
  }

  Clear_KBuffer();

  Puts(s(scan_all));

  lseek(areasidx,aidxoff=0L,SEEK_SET);

  tempmsg=usr.msg;

  while (read(areasidx,(char *)&aidx,sizeof(struct _aidx))==sizeof(struct _aidx))
  {
    Mdm_check();

    if (brk_trapped || mdm_halt())
    {
      brk_trapped=0;
      mdm_dump(DUMP_all);
      break;
    }

    if (aidx.area <= prm.high_msgarea && IsValidMsgArea(NULL,aidx.area) &&
        ExtBarricadeOK(&area,TRUE,NULL))
    {
      sprintf(temp,ss,area.msgpath,scanfile_name);

      if (fexist(temp))
        scan_datafile=TRUE;
      else
      {
        scan_datafile=FALSE;

        if (Save_Directory(area.msgpath)==-1)
        {
          logit(mem_ndir);
          Puts(mem_ndir);
          goto Cont;
        }

        Scan_Msg_Numbers(FALSE);
      }

      if (new)
        Scan_LastRead_Pointer();

      if (baud != 300L)
        Printf(s(msgn_cleol),Area_Name(aidx.area),area.msginfo);

      usr.msg=aidx.area;

      if (graph==GRAPHICS_none)
      {
        for (x=0,y=last_len-strlen(area.msginfo);x < y;x++)
          Putc(' ');

        last_len=strlen(area.msginfo);
      }

      Putc('\r');

      /* If user ^c's, then get out of loop! */
      if (Msg_List(aidx.area,new,verbose,&nonstop,scan_datafile,read_msg)==-1)
        break;
    }

Cont:

    lseek(areasidx,aidxoff += sizeof(struct _aidx),SEEK_SET);
  }

  usr.msg=tempmsg;

  if (graph==GRAPHICS_none)
  {
    for (x=0,y=last_len+16;x < y;x++)
      Putc(' ');
  }

  Puts(CLEOL "\r");

  IsValidMsgArea(NULL,usr.msg);
  Header_Message(ENTRY_nocheck);
  
/* Msg_Area_Scan(); */
  
  in_mcheck=FALSE;
}


/* If type==-1, then do a normal L)ist for the current area.  If           *
 * type != -1, then do a S)can (list only messages TO you) in the          *
 * area `type'.  A small variation from Opus' behavior -- When doing a     *
 * `L*' or a `S*', Maximus will only display messages from the last-read   *
 * message in that area (just as Opus does), but it will only display      *
 * messages TO you, and only those which HAVEN'T received.  Using `S*' or  *
 * `SR*' now gives you the functionality of a stand-alone mailchecker!     */

int pascal Msg_List(int type,char s_new,char s_verbose,char *s_nonstop,char scan_datafile,char read_msg)
{
  struct _msg msg,
              scan_msg[SCAN_BLOCK],
              *mptr;

  int msgfile,
      scanfile,
      startmsg,
      scan_num,
      scan_max,
      outmax,
      ret,
      ch,
      x,y;

  char temp[PATHLEN],
       msginf[133],         /* Temp. building area for each line */
       new,                 /* If we're listing all new messages */
       verbose,             /* If we do a verbose listing        */
       nonstop,             /* If we're doing non-stop listing   */
       got_one;             /* If we've found a msg in this area yet */


  new=verbose=got_one=FALSE;

  if (type==-1)
  {
    WhiteN();

    for (*temp='?';*temp=='?';)
    {
      OpusGetsLL(temp,PATHLEN,s(list_p));

      if (*temp=='?')
        Display_File(0,NULL,PRM(hlp_list));
    }

    Putc('\n');

    display_line=display_col=1;
    nonstop=FALSE;

    strupr(temp);

    while (temp[0]=='*' || temp[0]=='V' || isspace(temp[0]) ||
           ispunct(temp[0]))
    {
      if (temp[0]=='*')
        new=TRUE;
      else if (temp[0]=='V')
        verbose=TRUE;

      memmove(temp,&temp[1],strlen(&temp[1])+1);  /* Shift it back one */
    }
  }
  else
  {
    new=s_new;
    verbose=s_verbose;

    if (MoreYnBreak(type==-1 ? &nonstop : s_nonstop,CYAN))   /* User wants out? */
      return -1;
  }


  if (type==-1 && new)
    startmsg=last_msg;
  else
  {
    if (type != -1)
      startmsg=1;
    else if ((startmsg=atoi(temp))==0)
      startmsg=last_msg;
  }

  sprintf(temp,ss,area.msgpath,scanfile_name);

  if (scan_datafile && ((scanfile=shopen(temp,O_RDWR | O_BINARY))==-1))
  {
    if (Save_Directory(area.msgpath)==-1)
      return -1;

    scan_datafile=FALSE;
  }

  if (scan_datafile)
    num_msg=0x7fff;

  scan_num=SCAN_BLOCK;
  scan_max=-1;

  ret=0;


  for (x=0;x < num_msg;x++)
  {
    if (!read_msg && MoreYnBreak(type==-1 ? &nonstop : s_nonstop,CYAN))   /* User wants out? */
    {
      ret=-1;
      break;
    }

    if (brk_trapped || mdm_halt())
    {
      brk_trapped=0;
      mdm_dump(DUMP_all);
      ret=-1;
      break;
    }

    if (scan_datafile || (msgs[x] >= startmsg))
    {
      if (! scan_datafile)
        sprintf(temp,d_msg,msgs[x]);

      if (scan_datafile || (msgfile=shopen(temp,O_RDWR | O_BINARY)) != -1)
      {
        if (scan_datafile)
        {
          if (scan_num==SCAN_BLOCK || scan_num==scan_max)
          {
            /* If nuttin' else to read */
            if ((scan_max=read(scanfile,(char *)scan_msg,sizeof(struct _msg)*SCAN_BLOCK))==0)
              break;

            scan_max /= sizeof(struct _msg);
            scan_num=0;
          }

          mptr=&scan_msg[scan_num++];
        }
        else if (read(msgfile,(char *)(mptr=&msg),sizeof(struct _msg)) != sizeof(struct _msg))
        {
          close(msgfile);
          continue;
        }

        if (!new || (scan_datafile ? mptr->cost : msgs[x]) >= startmsg)
        {
          outmax=(usr.width > 78 ? usr.width : 78)-1;

          if (type==-1 ? (CanSeeMsg(mptr)) : (eqstri(mptr->to,usr.name)))
          {
            if (!new || (new && eqstri(mptr->to,usr.name) && !(mptr->attr & MSGREAD)))
            {
              found_msg=TRUE;

              mptr->from[35]='\0';
              mptr->to[35]='\0';
              mptr->subj[71]='\0';

              fancier_str(mptr->to);
              fancier_str(mptr->from);

              outmax += 6;   /* +3 for WHITE, +3 for CYAN */

              sprintf(msginf,WHITE "#%-4d " CYAN "%s %s ",
                      scan_datafile ? mptr->cost : msgs[x],
                      MsgDate(mptr,temp),
                      mptr->attr & MSGPRIVATE ? s(list_pvt) : s(list_nopvt));

              if (eqstri(mptr->to,usr.name) || eqstri(mptr->from,usr.name))
              {
                if (mptr->attr & MSGREAD)
                  strcat(msginf,s(list_recd));
                else if (eqstri(mptr->to,usr.name))  /* Only display NEW if it is */
                {                                    /* to us...                  */
                  outmax += 5;
                  strcat(msginf,s(list_new));
                }
                else strcat(msginf,s(list_nonewrecd));

                if (eqstri(mptr->from,usr.name))
                {
                  outmax += 6;

                  sprintf(&msginf[strlen(msginf)],
                          s(list_ab1),
                          mptr->to);
                }
                else
                {
                  outmax += 6;

                  sprintf(&msginf[strlen(msginf)],
                          s(list_ab2),
                          mptr->from);
                }
              }
              else sprintf(&msginf[strlen(msginf)],s(list_ab3),mptr->from,mptr->to);

              Strip_Ansi(msginf,usr.msg,scan_datafile ? mptr->cost : msgs[x]);

              if (strlen(msginf) > outmax)
              {
                msginf[outmax-1]='\n';
                msginf[outmax]='\0';
              }
              else strcat(msginf,"\n");

              if (!got_one && !read_msg)
                Putc('\n');

              if (read_msg)
              {
                if (scan_datafile)
                {
                  sprintf(temp,sd_msg,area.msgpath,mptr->cost);

                  if ((msgfile=shopen(temp,O_RDWR | O_BINARY))==-1)
                    continue;

                  read(msgfile,(char *)&msg,sizeof(struct _msg));
                }

                if (eqstri(mptr->to,msg.to) && (!new || (new && !(msg.attr & MSGREAD))))
                {
                  ch='A';

                  while (ch=='A' && ret==0)
                  {
                    Puts(CLS);

                    y=menu_lines;
                    menu_lines=1;

                    lseek(msgfile,(long)sizeof(struct _msg),SEEK_SET);

                    Printf(s(mchk_area),Area_Name(area.areano),area.msginfo);

                    Msg_Display(msgfile,&msg,usr.more,usr.msg,
                                (scan_datafile ? mptr->cost : msgs[x]),1);

                    menu_lines=y;

                    Recd_Msg(msgfile,&msg,
                             scan_datafile ? mptr->cost : msgs[x],
                             scan_datafile ? scanfile   : -1);

                    for (ch='R';ch=='R';)
                    {
                      *linebuf='\0';
                      WhiteN();

                      display_line=display_col=1;

                      strcpy(temp,s(mchk_nmsg));
                      strcpy(msginf,"Yna");

                      if (GEPriv(usr.priv,prm.mc_reply_priv))
                      {
                        strcat(temp,s(mchk_reply));
                        strcat(msginf,"r");
                      }

                      if (GEPriv(usr.priv,prm.mc_kill_priv))
                      {
                        strcat(temp,s(mchk_kill));
                        strcat(msginf,"k");
                      }

                      strcat(temp,s(end_prompt));

                      ch=GetListAnswer(msginf,NULL,s(mchk_nunder),
                                       CINPUT_fullprompt,
                                       temp);

                      switch(toupper(ch))
                      {
                        case YES:
                          break;

                        case NO:
                          close(msgfile);
                          msgfile=-1;
                          ret=-1;
                          break;

                        case 'R':
                          Save_Directory(area.msgpath);
                          last_msg=(scan_datafile ? mptr->cost : msgs[x]);
                          Msg_Reply();

                          /* Since Msg_Reply() will adjust the num_msg     *
                           * variable (indirectly through Save_Msg()), we  *
                           * should fix it upon return.                    */

                          if (scan_datafile)
                            num_msg=0x7fff;
                          break;

                        case 'K':
                          if (scan_datafile)
                          {
                            num_msg=0;
                            high_msg=0;
                          }
                          
                          close(msgfile);
                          msgfile=-1;

                          Msg_Kill((scan_datafile ? mptr->cost : msgs[x]));

                          if (scan_datafile)
                            num_msg=0x7fff;
                          break;
                      }
                    }
                  }

                  if (ret==-1)
                    break;
                }

                if (scan_datafile && msgfile != -1) /* Otherwise it'll get closed down below */
                  close(msgfile);
              }
              else
              {
                if (new && scan_datafile)
                {
                  sprintf(temp,sd_msg,area.msgpath,mptr->cost);

                  if ((msgfile=shopen(temp,O_RDWR | O_BINARY))==-1)
                    continue;

                  read(msgfile,(char *)&msg,sizeof(struct _msg));
                  close(msgfile);

                  if (msg.attr & MSGREAD)
                    continue;
                }

                Puts(msginf);

                if (verbose)
                {
                  if (MoreYnBreak(type==-1 ? &nonstop : s_nonstop,CYAN))
                  {
                    ret=-1;
                    break;
                  }

                  Printf(LCYAN "      %0.*s\n",outmax-5,mptr->subj);
                }
              }

              got_one=TRUE;
            }
          }
        }

        if (!scan_datafile && msgfile != -1)
          close(msgfile);
      }
    }

    Mdm_check();
  }

  if (scan_datafile)
    close(scanfile);

  Clear_KBuffer();

  if (got_one && !read_msg)
    Putc('\n');

  return ret;
}


void pascal Msg_Kill(int n)
{
  struct _msg msg;

  int msgnum,
      msgfile,
      x;

  char temp[BUFLEN];

  if (n==-1)
  {
    WhiteN();

    OpusGets(temp,s(kill_which));

    if (eqstri(temp,eq))
      msgnum=last_msg;
    else msgnum=atoi(temp);
  }
  else msgnum=n;

  sprintf(temp,sd_msg,area.msgpath,msgnum);

  if (msgnum)
  {
    if ((msgfile=shopen(temp,O_RDONLY | O_BINARY))==-1)
    {
      Puts(cantkill);
      Press_ENTER();
    }
    else
    {
      if (read(msgfile,(char *)&msg,sizeof(struct _msg))==sizeof(struct _msg) &&
          CanKillMsg(&msg))
      {
        close(msgfile);

        if (unlink(temp) == -1)
        {
          Puts(cantkill);
          Press_ENTER();
        }
        else    
        {
          /* Bump the high-water mark down by one, since this message
             was the last in the area!                                */

          if (msgnum==high_msg && (area.attrib[class] & ECHOMAIL))
          {
            if ((msgfile=shopen("1.MSG",O_RDWR | O_BINARY)) != -1)
            {
              read(msgfile,(char *)&msg,sizeof(struct _msg));

              if (msg.reply >= high_msg || msg.up >= high_msg)
              {
                if (msg.reply >= high_msg)
                  msg.reply=(num_msg==1 ? 0 : msgs[num_msg-2]);

                if (msg.up >= high_msg)
                  msg.up=(num_msg==1 ? 0 : msgs[num_msg-2]);

                lseek(msgfile,0L,SEEK_SET);
                write(msgfile,(char *)&msg,sizeof(struct _msg));
              }

              close(msgfile);
            }
            /* else no high-water mark, don't worry about it! */
          }

          /* Now update the in-memory message chain */

          for (x=0;x < num_msg;x++)
          {
            if (msgs[x]==msgnum)
            {
              if (msgnum != high_msg)
                memmove(&msgs[x],&msgs[x+1],(num_msg-(x+1))*sizeof(int)+1);
              else
              {
                high_msg=(num_msg==1 ? 0 : msgs[x-1]);

                if (last_msg > high_msg)
                  last_msg=high_msg;
              }

              break;
            }
          }

          /* Now remove it from SCANFILE.DAT */

          Update_Scanfile(1,msgnum,-1);

          logit(s(log_kill),temp);

          Puts(CLS);
          Printf(s(kill_done),msgnum);

          num_msg--;
        }
      }
      else
      {
        Puts(cantkill);
        Press_ENTER();

        close(msgfile);
      }
    }
  }
}



/* Check to see if the user has enough privs to kill a message. */

static int near pascal CanKillMsg(struct _msg *msg)
{
  return (eqstri(Strip_Trailing_Blanks(msg->to),usr.name) ||
          eqstri(Strip_Trailing_Blanks(msg->from),usr.name) ||
          GEPriv(usr.priv,prm.pvt_priv));
}



void pascal Msg_Forward(void)
{
  struct _msg msg,
              mmsg;

  char bufr[FWD_BUFSIZ+1],
       orig_area[40],
       temp[PATHLEN],
       break_loop,
       bombrun,
       killmsg,
       *save_p,
       *p;

  int msgnum,
      msgfile,
      outmsgfile,
      slmsg,
      an,
      save_usrmsg,
      other_area,
      x;

  Puts(WHITE);

  mknl(temp);
  mknl(netnode);
  mknl(orig_msgid);
  bombrun=killmsg=FALSE;
  slmsg=last_msg;

  while (1)
  {
    WhiteN();

    if (isnl(temp))
      OpusGets(temp,s(fwd_which));

    while (isalpha(*temp))
    {
      switch (toupper(*temp))
      {
        case 'B':
          bombrun=TRUE;
          break;

        case 'K':
          killmsg=TRUE;
          break;
      }

      memmove(temp,&temp[1],strlen(&temp[1])+1);
    }

    if ((bombrun || killmsg) && isnl(temp))
      continue;
    else break;
  }

  /* Only local users, or remote users with a priv greater than            *
   * msg_fromfile can do bombing runs, since it gives them access to       *
   * our HD.                                                               */

  if (bombrun && !GEPriv(realpriv(),prm.msg_fromfile) && !local)
  {
    You_Cant_Get_There();
    return;
  }

  if (eqstri(temp,eq))
    msgnum=last_msg;
  else msgnum=atoi(temp);

  if (msgnum)
  {
    Fix_Lastread();

    sprintf(temp,d_msg,msgnum);

    if ((msgfile=shopen(temp,O_RDONLY | O_BINARY)) != -1)
    {
      if (read(msgfile,(char *)&mmsg,sizeof(struct _msg))==sizeof(struct _msg) &&
          CanSeeMsg(&mmsg))
      {
        an=usr.msg;

        if (GetYnAnswer(s(use_this_area),0)==NO)
        {
          other_area=TRUE;
          
          strcpy(orig_area,area.msgname);

          for (strcpy(temp,qmark);eqstri(temp,qmark);)
          {
            OpusGets(temp,s(which_area));

            if (eqstri(temp,qmark))
              List_Message_Areas();
          }

          if (! *temp)
          {
            close(msgfile);
            return;
          }
          else an=Set_Area_Name(temp);

          if (!IsValidMsgArea(NULL,an) ||
              (!ExtBarricadeOK(&area,TRUE,&x) && x) || 
              Save_Directory(area.msgpath)==-1)
          {
            Puts(areadoesntexist);
            Press_ENTER();

            IsValidMsgArea(NULL,usr.msg);
            Header_Message(ENTRY_nocheck);

            last_msg=slmsg;
            return;
          }

          Scan_Msg_Numbers(FALSE);

          /* Set the bit field, for the echo tosslog */

          if (*area.msgname)
            BitOn(echo_written_in,(int)(Index_of_Area(area.areano)/(long)sizeof(struct _area)));
        }
        else
        {
          other_area=FALSE;
          *orig_area='\0';
          an=usr.msg;
        }

        while (1)
        {
          Blank_Msg(&msg);
          strcpy(msg.subj,mmsg.subj);
          mknl(netnode);

          save_usrmsg=usr.msg;  /* So that Get_Msg_Attr displays right area number */
          usr.msg=an;

          if (bombrun)
          {
            if (Read_Bomb_File(&msg)==-1)
              break;

            Printf(s(fwd_to),
                   msg.to,zoneto,msg.dest_net,msg.dest,pointto);

            if (Check_Credit(zoneto,msg.dest_net,msg.dest)==-1)
            {
              last_msg=slmsg;
              return;
            }
          }
          else if (Get_Msg_Attr(&msg)==-1 || Check_Credit(zoneto,msg.dest_net,msg.dest)==-1)
          {
            close(msgfile);

            IsValidMsgArea(NULL,usr.msg=save_usrmsg);
            Header_Message(ENTRY_nocheck); /* Re-scan current area */

            Puts(msg_aborted);

            last_msg=slmsg;
            return;
          }

          usr.msg=save_usrmsg;

          if (num_msg+1 < MAX_MSG)
          {
            sprintf(temp,d_msg,high_msg+1);

            if ((outmsgfile=sopen(temp,O_CREAT | O_BINARY | O_WRONLY,SH_DENYNONE,
                                 S_IREAD | S_IWRITE)) != -1)
            {
              write(outmsgfile,(char *)&msg,sizeof(struct _msg));

              Insert_Message_Kludges(outmsgfile,&msg,zoneto,pointto);

              if (*orig_area)
                lprintf(outmsgfile,s(org_area),orig_area);

              lprintf(outmsgfile,s(orig_from),mmsg.from);
              lprintf(outmsgfile,s(orig_to),mmsg.to);

              if (prm.address[0].Zone && prm.address[0].Net)
                lprintf(outmsgfile,s(orig_by),
                        us,version,prm.address[0].Zone,prm.address[0].Net,
                        prm.address[0].Node,prm.address[0].Point);

              lseek(msgfile,(long)sizeof(struct _msg),SEEK_SET);

              break_loop=FALSE;

              while (1)
              {
                if ((x=read(msgfile,bufr,FWD_BUFSIZ))==0)
                  break;

                /* Strip off trailing NULs */
                while (x && bufr[x-1]=='\0')
                  x--;

                bufr[FWD_BUFSIZ]='\0';

                if (area.attrib[class] & ECHOMAIL) /* Only strip if fwding to echo area */
                {
                  /* Since the buffer always overlaps by FWD_OVERLAP each
                     time, we'll always catch the SEEN-BYs!                */

                  p=bufr;

                  while (p && ((p=stristr(p,"\n---")) != NULL ||
                               (p=stristr(p,"\r---")) != NULL))
                  {
                    save_p=p;

                    for (p += 4;*p;p++)
                      if (*p=='\n' || *p=='\r')
                      {
                        while (*p=='\n' || *p=='\r')
                          p++;

                        break;
                      }

                    if (*p==' ' && *++p=='*' && *++p==' ' &&
                        *++p=='O' && *++p=='r' && *++p=='i' &&
                        *++p=='g' && *++p=='i' && *++p=='n' && *++p==':')
                    {
                      /* Write everything up to, but not including their origin */
                      write(outmsgfile,bufr,((int)(save_p-bufr)-((*save_p=='\r' || *save_p=='\n') ? 1 : 0)));

/*                    Write_Origin_Line(outmsgfile); */

                      break_loop=TRUE;
                      break;
                    }
                    else p=++save_p;
                  }

                  if (break_loop)
                    break;

                  if (p==NULL)
                    write(outmsgfile,bufr,x > FWD_OVERLAP && !eof(msgfile) ? x-FWD_OVERLAP : x);
                }
                else write(outmsgfile,bufr,x > FWD_OVERLAP && !eof(msgfile) ? x-FWD_OVERLAP : x);

                if (eof(msgfile))
                  break;

                /* Back up by FWD_OVERLAP bytes */
                lseek(msgfile,-(long)FWD_OVERLAP,SEEK_CUR);
              }

              /* If we didn't do this before */
              if (area.attrib[class] & ECHOMAIL)
                Write_Origin_Line(outmsgfile);

              msgs[num_msg++]=++high_msg; /* Update the message chain */

              close(outmsgfile);

              if (msg.dest_net != prm.address[0].Net ||
                  msg.dest != prm.address[0].Node)
              {
                if (!bombrun)
                  Putc('\n');

                if (area.attrib[class] & SYSMAIL)
                  Handle_Matrix_Charges(zoneto,msg.dest_net,msg.dest,bombrun==FALSE);
              }

              logit(s(log_fwd),msg.to,Area_Name(an),high_msg);
            }
            else logit(cantwrite,temp);
          }
          else
          {
            Puts(toomanymessages);
            logit(ltoomanymessages,area.msgpath,MAX_MSG);
          }

          if (! bombrun)
            break;
        }

        close(msgfile);

        if (other_area)
        {
          IsValidMsgArea(NULL,usr.msg=save_usrmsg);
          Header_Message(ENTRY_nocheck);
        }
        
        if (killmsg)
          Msg_Kill(msgnum);
      }
      else close(msgfile);
    }
  }

  last_msg=slmsg;

  Putc('\n');
  Putc('\n');
}



int pascal Read_Bomb_File(struct _msg *msg)
{
  char temp[PATHLEN],
       *p;

  static FILE *bombfile=NULL;

  if (bombfile==NULL)
  {
    Putc('\n');

    OpusGets(temp,s(get_route_file));

    if (! *temp)
      return -1;

    if ((bombfile=shfopen(temp,fopen_read,O_RDONLY))==NULL)
    {
      Printf(iseenoxhere,temp);
      return -1;
    }
  }

  while (1)
  {
    fgets(temp,PATHLEN-1,bombfile);
    Trim_Line(temp);

    if (feof(bombfile))
    {
      fclose(bombfile);
      bombfile=NULL;
      return -1;
    }

    if (! isblstr(temp))
    {
      p=strtok(temp,cmd_delim);

      while (p != NULL)
      {
        if (isnl(msg->to))
          strcpy(msg->to,fancier_str(Strip_Underscore(p)));
        else if (isdigit(*p))
        {
          strcpy(netnode,p);
          Parse_NetNode(netnode,&zoneto,&msg->dest_net,&msg->dest,&pointto);

          sprintf(netnode,znnp,zoneto,msg->dest_net,msg->dest,pointto);
        }
        else if (*p=='-')
        {
          switch (toupper(*(p+1)))
          {
            case 'C':
              msg->attr |= MSGCRASH;
              break;

            case 'D':
              msg->attr |= MSGXX2;  /* I think -- How DO you specify a DIRECT */
              break;                /* message, anyways?!                     */

            case 'H':
              msg->attr |= MSGHOLD;
              break;

            case 'N':
              break;

            default:
              Printf(huh,p);
              break;
          }
        }
        else Printf(huh,p);

        p=strtok(NULL,cmd_delim);
      }

      break;
    }
  }

  return 0;
}



void pascal Msg_Hurl(void)
{
  struct _msg msg;

  char temp[PATHLEN],
       temp2[PATHLEN];

  int msgnum,
      msgfile,
      slmsg,
      an,
      x;

  slmsg=last_msg;

  Fix_Lastread();

  WhiteN();

  OpusGets(temp,s(hurl_which));

  if (eqstri(temp,eq))
    msgnum=last_msg;
  else msgnum=atoi(temp);

  if (msgnum)
  {
    sprintf(temp,sd_msg,area.msgpath,msgnum);

    if ((msgfile=shopen(temp,O_RDONLY | O_BINARY)) != -1)
    {
      x=read(msgfile,(char *)&msg,sizeof(struct _msg));
      close(msgfile);

      if (x==sizeof(struct _msg) && CanSeeMsg(&msg))
      {
        an=usr.msg;

        for (strcpy(temp2,qmark);eqstri(temp2,qmark);)
        {
          OpusGets(temp2,s(which_area));

          if (eqstri(temp2,qmark))
            List_Message_Areas();
        }

        if (! *temp2)
          return;
        else an=Set_Area_Name(temp2);

        if (IsValidMsgArea(NULL,an) && (ExtBarricadeOK(&area,TRUE,&x) || x==FALSE))
        {
          if (Save_Directory(area.msgpath)==-1)
          {
            logit(mem_ndir);
            Puts(mem_ndir);
            an=usr.msg;

            /* Re-read current area */
            IsValidMsgArea(NULL,usr.msg);

            last_msg=slmsg;
            return;
          }
        }
        else
        {
          Puts(areadoesntexist);
          Press_ENTER();

          /* Re-read current area */
          IsValidMsgArea(NULL,usr.msg);

          last_msg=slmsg;
          return;
        }

        Msg_Area_Scan();

        entry=ENTRY_nocheck; /* Re-scan area */

        if (num_msg+1 < MAX_MSG)
        {
          sprintf(temp2,sd_msg,area.msgpath,high_msg+1);
          Printf(hurling,temp,temp2);

          /* Set the bit field, for the echo tosslog */

          if (*area.msgname)
            BitOn(echo_written_in,(int)(Index_of_Area(area.areano)/(long)sizeof(struct _area)));

          if (move_file(temp,temp2)==-1)
          {
            Puts(s(hurl_cant));
            Press_ENTER();
          }
          else
          {
            /* Now nuke the up/down threads */
            if ((msgfile=sopen(temp2,O_RDWR | O_BINARY,SH_DENYNONE,S_IREAD | S_IWRITE)) != -1)
            {
              read(msgfile,(char *)&msg,sizeof(struct _msg));
              msg.up=msg.reply=0;

              lseek(msgfile,0L,SEEK_SET);
              write(msgfile,(char *)&msg,sizeof(struct _msg));
              close(msgfile);
            }

            Puts(done);
          }
        }
        else
        {
          Puts(toomanymessages);
          logit(ltoomanymessages,area.msgpath,MAX_MSG);
        }
      }
    }
  }

  IsValidMsgArea(NULL,usr.msg);

  if (entry==ENTRY_nocheck)
  {
    Header_Message(entry);
    entry=ENTRY_false;
  }

  last_msg=slmsg;
}



void pascal Msg_Xport(void)
{
  FILE *outfile;

  struct _msg msg;

  int msgnum,
      msgfile,
      x;

  char temp[PATHLEN],
       temp2[PATHLEN],
       outline[MAX_LINELEN], /* The output message line */
       linetype[1],
       last_msg_attr,
       *p[1];

  msgeof=FALSE;
  last_msg_attr=0;

  WhiteN();

  OpusGets(temp,s(xport_which));

  if (eqstri(temp,eq))
    msgnum=last_msg;
  else msgnum=atoi(temp);

  if (msgnum)
  {
    sprintf(temp,d_msg,msgnum);

    if ((msgfile=shopen(temp,O_RDONLY | O_BINARY)) != -1)
    {
      if (read(msgfile,(char *)&msg,sizeof(struct _msg))==sizeof(struct _msg) &&
          CanSeeMsg(&msg))
      {
        OpusGets(temp2,s(xport_where));
        
        if (! *temp2)
        {
          close(msgfile);
          return;
        }

        Puts(s(xporting));

        if ((outfile=shfopen(temp2,fopen_append,O_WRONLY | O_APPEND)) != NULL)
        {
          msg.from[35]='\0';
          msg.to[35]='\0';
          msg.subj[71]='\0';

          fprintf(outfile,s(xp_hdr1),areatag,msgnum,
                  MsgDate(&msg,temp));

          fprintf(outfile,s(xp_hdr2),Strip_Ansi(msg.from,0,0));
          fprintf(outfile,s(xp_hdr3),Strip_Ansi(msg.to,0,0));
          fprintf(outfile,s(xp_hdr4),Strip_Ansi(msg.subj,0,0));

          *p=outline;
          while (Msg_Read_Lines(msgfile,1,79,p,linetype,&last_msg_attr) > 0)
          {
            if (linetype[0] & MSGLINE_seenby)
            {
              if (! GEPriv(usr.priv,prm.seenby_priv))
                continue;
            }
            else if (linetype[0] & MSGLINE_kludge)
            {
              if (! GEPriv(usr.priv,prm.ctla_priv))
                continue;
            }

            fprintf(outfile,"%s\n",outline);
          }

          for (x=0;x < 39;x++)
            fputs("--",outfile);

          fputs("\n\n",outfile);
          fclose(outfile);
        }
        else Printf(&cantopen[1],temp2);
      }

      close(msgfile);
      Puts(done);
    }
  }
}


void pascal Msg_Upload(void)
{
  FILE *inmsg;
  struct _msg msg;

  char temp[PATHLEN],
       *filename,
       *p;

  int aborted;

  if (local)
  {
    Puts(err999_1);
    OpusGets(temp,err999_2);

    return;
  }

  aborted=isareply=FALSE;

  Blank_Msg(&msg);
  mknl(netnode);
  mknl(orig_msgid);

  if (Get_Msg_Attr(&msg)==-1)
    aborted=TRUE;
  else
  {
    Puts(s(ul_reject));
    Puts(s(ul_ctrlx));

    if ((Txbuf=Secbuf=zalloc()) != NULL)
    {
      sprintf(temp,msgtemp_name,PRM(temppath),task_num);

      if ((p=strrchr(temp,'\\')) != NULL)
        p++;
      else p=temp;

      Mdm_flush();
      Mdm_Flow_Off();

      in_file_xfer=TRUE;
      filename=receive_file(PRM(temppath),p,'X');
      in_file_xfer=FALSE;

      mdm_dump(DUMP_input);
      Clear_KBuffer();
      Mdm_Flow_On();

      free(Txbuf);
      Txbuf=Secbuf=NULL;

      if (filename)
      {
        if ((inmsg=shfopen(temp,fopen_readb,O_RDONLY | O_BINARY))==NULL)
        {
          logit(cantopen,temp);
          aborted=TRUE;
        }
        else
        {
          aborted=Save_Msg(&msg,inmsg,FALSE,0,0);
          fclose(inmsg);
        }

        unlink(temp);
      }
      else aborted=TRUE;
    }
    else aborted=TRUE;
  }

  if (aborted)
    Puts(msg_aborted);
}

#include "isvma.c"
#include "lread.c"
#include "msgdate.c"
#include "updsf.c"

